diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/block-ack-manager.cc ns-3.38/src/wifi/model/block-ack-manager.cc
--- ns-3.37/src/wifi/model/block-ack-manager.cc	2022-11-01 17:37:24.739395900 -0700
+++ ns-3.38/src/wifi/model/block-ack-manager.cc	2023-03-16 20:54:23.852869300 -0700
@@ -672,116 +660,150 @@
 }
 
 void
-BlockAckManager::ScheduleBar(Ptr<const WifiMpdu> bar, bool skipIfNoDataQueued)
+BlockAckManager::ScheduleBar(Ptr<WifiMpdu> bar)
 {
     NS_LOG_FUNCTION(this << *bar);
-    NS_ASSERT(bar->GetHeader().IsBlockAckReq() || bar->GetHeader().IsTrigger());
+    NS_ASSERT(bar->GetHeader().IsBlockAckReq());
 
-    uint8_t tid = 0;
-    if (bar->GetHeader().IsBlockAckReq())
-    {
-        CtrlBAckRequestHeader reqHdr;
-        bar->GetPacket()->PeekHeader(reqHdr);
-        tid = reqHdr.GetTidInfo();
-    }
-#ifdef NS3_BUILD_PROFILE_DEBUG
-    else
-    {
-        CtrlTriggerHeader triggerHdr;
-        bar->GetPacket()->PeekHeader(triggerHdr);
-        NS_ASSERT(triggerHdr.IsMuBar());
-    }
-#endif
-    Bar request(bar, tid, skipIfNoDataQueued);
+    CtrlBAckRequestHeader reqHdr;
+    bar->GetPacket()->PeekHeader(reqHdr);
+    uint8_t tid = reqHdr.GetTidInfo();
 
-    // if a BAR for the given agreement is present, replace it with the new one
-    std::list<Bar>::const_iterator i = m_bars.end();
+    WifiContainerQueueId queueId(WIFI_CTL_QUEUE, bar->GetHeader().GetAddr2(), std::nullopt);
+    Ptr<WifiMpdu> item = nullptr;
 
-    if (bar->GetHeader().IsBlockAckReq())
+    // if a BAR for the given agreement is present, replace it with the new one
+    while ((item = m_queue->PeekByQueueId(queueId, item)))
     {
-        for (i = m_bars.begin(); i != m_bars.end(); i++)
+        if (item->GetHeader().IsBlockAckReq() &&
+            item->GetHeader().GetAddr1() == bar->GetHeader().GetAddr1())
         {
-            if (i->bar->GetHeader().IsBlockAckReq() &&
-                i->bar->GetHeader().GetAddr1() == bar->GetHeader().GetAddr1() && i->tid == tid)
+            CtrlBAckRequestHeader otherHdr;
+            item->GetPacket()->PeekHeader(otherHdr);
+            if (otherHdr.GetTidInfo() == tid)
             {
-                i = m_bars.erase(i);
-                break;
+                // replace item with bar
+                m_queue->Replace(item, bar);
+                return;
             }
         }
     }
 
-    if (bar->GetHeader().IsRetry())
-    {
-        m_bars.push_front(request);
-    }
-    else
+    m_queue->Enqueue(bar);
+}
+
+void
+BlockAckManager::ScheduleMuBar(Ptr<WifiMpdu> muBar)
+{
+    NS_LOG_FUNCTION(this << *muBar);
+    NS_ASSERT(muBar->GetHeader().IsTrigger());
+
+#ifdef NS3_BUILD_PROFILE_DEBUG
+    CtrlTriggerHeader triggerHdr;
+    muBar->GetPacket()->PeekHeader(triggerHdr);
+    NS_ASSERT(triggerHdr.IsMuBar());
+#endif
+
+    m_queue->Enqueue(muBar);
+}
+
+const std::list<BlockAckManager::AgreementKey>&
+BlockAckManager::GetSendBarIfDataQueuedList() const
+{
+    return m_sendBarIfDataQueued;
+}
+
+void
+BlockAckManager::AddToSendBarIfDataQueuedList(const Mac48Address& recipient, uint8_t tid)
+{
+    NS_LOG_FUNCTION(this << recipient << tid);
+    // do nothing if the given pair is already in the list
+    if (std::find(m_sendBarIfDataQueued.begin(),
+                  m_sendBarIfDataQueued.end(),
+                  BlockAckManager::AgreementKey{recipient, tid}) == m_sendBarIfDataQueued.end())
     {
-        m_bars.insert(i, request);
+        m_sendBarIfDataQueued.emplace_back(recipient, tid);
     }
 }
 
 void
-BlockAckManager::InactivityTimeout(Mac48Address recipient, uint8_t tid)
+BlockAckManager::RemoveFromSendBarIfDataQueuedList(const Mac48Address& recipient, uint8_t tid)
+{
+    NS_LOG_FUNCTION(this << recipient << tid);
+    m_sendBarIfDataQueued.remove({recipient, tid});
+}
+
+void
+BlockAckManager::InactivityTimeout(const Mac48Address& recipient, uint8_t tid)
 {
     NS_LOG_FUNCTION(this << recipient << +tid);
     m_blockAckInactivityTimeout(recipient, tid, true);
 }
 
 void
-BlockAckManager::NotifyAgreementEstablished(Mac48Address recipient,
-                                            uint8_t tid,
-                                            uint16_t startingSeq)
+BlockAckManager::NotifyOriginatorAgreementEstablished(const Mac48Address& recipient,
+                                                      uint8_t tid,
+                                                      uint16_t startingSeq)
 {
     NS_LOG_FUNCTION(this << recipient << +tid << startingSeq);
-    AgreementsI it = m_agreements.find(std::make_pair(recipient, tid));
-    NS_ASSERT(it != m_agreements.end());
+    auto it = m_originatorAgreements.find({recipient, tid});
+    NS_ASSERT(it != m_originatorAgreements.end());
     if (!it->second.first.IsEstablished())
     {
-        m_agreementState(Simulator::Now(),
-                         recipient,
-                         tid,
-                         OriginatorBlockAckAgreement::ESTABLISHED);
+        m_originatorAgreementState(Simulator::Now(),
+                                   recipient,
+                                   tid,
+                                   OriginatorBlockAckAgreement::ESTABLISHED);
     }
     it->second.first.SetState(OriginatorBlockAckAgreement::ESTABLISHED);
     it->second.first.SetStartingSequence(startingSeq);
 }
 
 void
-BlockAckManager::NotifyAgreementRejected(Mac48Address recipient, uint8_t tid)
+BlockAckManager::NotifyOriginatorAgreementRejected(const Mac48Address& recipient, uint8_t tid)
 {
     NS_LOG_FUNCTION(this << recipient << +tid);
-    AgreementsI it = m_agreements.find(std::make_pair(recipient, tid));
-    NS_ASSERT(it != m_agreements.end());
+    auto it = m_originatorAgreements.find({recipient, tid});
+    NS_ASSERT(it != m_originatorAgreements.end());
     if (!it->second.first.IsRejected())
     {
-        m_agreementState(Simulator::Now(), recipient, tid, OriginatorBlockAckAgreement::REJECTED);
+        m_originatorAgreementState(Simulator::Now(),
+                                   recipient,
+                                   tid,
+                                   OriginatorBlockAckAgreement::REJECTED);
     }
     it->second.first.SetState(OriginatorBlockAckAgreement::REJECTED);
 }
 
 void
-BlockAckManager::NotifyAgreementNoReply(Mac48Address recipient, uint8_t tid)
+BlockAckManager::NotifyOriginatorAgreementNoReply(const Mac48Address& recipient, uint8_t tid)
 {
     NS_LOG_FUNCTION(this << recipient << +tid);
-    AgreementsI it = m_agreements.find(std::make_pair(recipient, tid));
-    NS_ASSERT(it != m_agreements.end());
+    auto it = m_originatorAgreements.find({recipient, tid});
+    NS_ASSERT(it != m_originatorAgreements.end());
     if (!it->second.first.IsNoReply())
     {
-        m_agreementState(Simulator::Now(), recipient, tid, OriginatorBlockAckAgreement::NO_REPLY);
+        m_originatorAgreementState(Simulator::Now(),
+                                   recipient,
+                                   tid,
+                                   OriginatorBlockAckAgreement::NO_REPLY);
     }
     it->second.first.SetState(OriginatorBlockAckAgreement::NO_REPLY);
     m_unblockPackets(recipient, tid);
 }
 
 void
-BlockAckManager::NotifyAgreementReset(Mac48Address recipient, uint8_t tid)
+BlockAckManager::NotifyOriginatorAgreementReset(const Mac48Address& recipient, uint8_t tid)
 {
     NS_LOG_FUNCTION(this << recipient << +tid);
-    AgreementsI it = m_agreements.find(std::make_pair(recipient, tid));
-    NS_ASSERT(it != m_agreements.end());
+    auto it = m_originatorAgreements.find({recipient, tid});
+    NS_ASSERT(it != m_originatorAgreements.end());
     if (!it->second.first.IsReset())
     {
-        m_agreementState(Simulator::Now(), recipient, tid, OriginatorBlockAckAgreement::RESET);
+        m_originatorAgreementState(Simulator::Now(),
+                                   recipient,
+                                   tid,
+                                   OriginatorBlockAckAgreement::RESET);
     }
     it->second.first.SetState(OriginatorBlockAckAgreement::RESET);
 }
@@ -794,50 +816,31 @@
 }
 
 bool
-BlockAckManager::SwitchToBlockAckIfNeeded(Mac48Address recipient, uint8_t tid, uint16_t startingSeq)
+BlockAckManager::NeedBarRetransmission(uint8_t tid, const Mac48Address& recipient)
 {
-    NS_LOG_FUNCTION(this << recipient << +tid << startingSeq);
-    NS_ASSERT(!ExistsAgreementInState(recipient, tid, OriginatorBlockAckAgreement::PENDING));
-    if (!ExistsAgreementInState(recipient, tid, OriginatorBlockAckAgreement::REJECTED) &&
-        ExistsAgreement(recipient, tid))
-    {
-        WifiContainerQueueId queueId{WIFI_QOSDATA_UNICAST_QUEUE, recipient, tid};
-        uint32_t packets = m_queue->GetNPackets(queueId) + GetNBufferedPackets(recipient, tid);
-        if (packets >= m_blockAckThreshold)
-        {
-            NotifyAgreementEstablished(recipient, tid, startingSeq);
-            return true;
-        }
+    auto it = m_originatorAgreements.find({recipient, tid});
+    if (it == m_originatorAgreements.end() || !it->second.first.IsEstablished())
+    {
+        // If the inactivity timer has expired, QosTxop::SendDelbaFrame has been called and
+        // has destroyed the agreement, hence we get here and correctly return false
+        return false;
     }
-    return false;
-}
 
-bool
-BlockAckManager::NeedBarRetransmission(uint8_t tid, Mac48Address recipient)
-{
-    if (ExistsAgreementInState(recipient, tid, OriginatorBlockAckAgreement::ESTABLISHED))
-    {
-        AgreementsI it = m_agreements.find(std::make_pair(recipient, tid));
-        NS_ASSERT(it != m_agreements.end());
+    Time now = Simulator::Now();
 
-        Time now = Simulator::Now();
+    // A BAR needs to be retransmitted if there is at least a non-expired in flight MPDU
+    for (auto mpduIt = it->second.second.begin(); mpduIt != it->second.second.end();)
+    {
+        // remove MPDU if old or with expired lifetime
+        mpduIt = HandleInFlightMpdu(SINGLE_LINK_OP_ID, mpduIt, STAY_INFLIGHT, it, now);
 
-        // A BAR needs to be retransmitted if there is at least a non-expired in flight MPDU
-        for (auto mpduIt = it->second.second.begin(); mpduIt != it->second.second.end();)
+        if (mpduIt != it->second.second.begin())
         {
-            // remove MPDU if old or with expired lifetime
-            mpduIt = HandleInFlightMpdu(mpduIt, STAY_INFLIGHT, it, now);
-
-            if (mpduIt != it->second.second.begin())
-            {
-                // the MPDU has not been removed
-                return true;
-            }
+            // the MPDU has not been removed
+            return true;
         }
     }
 
-    // If the inactivity timer has expired, QosTxop::SendDelbaFrame has been called and
-    // has destroyed the agreement, hence we get here and correctly return false
     return false;
 }
 
@@ -881,39 +884,23 @@
 }
 
 uint16_t
-BlockAckManager::GetRecipientBufferSize(Mac48Address recipient, uint8_t tid) const
+BlockAckManager::GetRecipientBufferSize(const Mac48Address& recipient, uint8_t tid) const
 {
     uint16_t size = 0;
-    AgreementsCI it = m_agreements.find(std::make_pair(recipient, tid));
-    if (it != m_agreements.end())
+    auto it = m_originatorAgreements.find({recipient, tid});
+    if (it != m_originatorAgreements.end())
     {
         size = it->second.first.GetBufferSize();
     }
     return size;
 }
 
-BlockAckReqType
-BlockAckManager::GetBlockAckReqType(Mac48Address recipient, uint8_t tid) const
-{
-    AgreementsCI it = m_agreements.find(std::make_pair(recipient, tid));
-    NS_ABORT_MSG_IF(it == m_agreements.end(), "No established Block Ack agreement");
-    return it->second.first.GetBlockAckReqType();
-}
-
-BlockAckType
-BlockAckManager::GetBlockAckType(Mac48Address recipient, uint8_t tid) const
-{
-    AgreementsCI it = m_agreements.find(std::make_pair(recipient, tid));
-    NS_ABORT_MSG_IF(it == m_agreements.end(), "No established Block Ack agreement");
-    return it->second.first.GetBlockAckType();
-}
-
 uint16_t
-BlockAckManager::GetOriginatorStartingSequence(Mac48Address recipient, uint8_t tid) const
+BlockAckManager::GetOriginatorStartingSequence(const Mac48Address& recipient, uint8_t tid) const
 {
     uint16_t seqNum = 0;
-    AgreementsCI it = m_agreements.find(std::make_pair(recipient, tid));
-    if (it != m_agreements.end())
+    auto it = m_originatorAgreements.find({recipient, tid});
+    if (it != m_originatorAgreements.end())
     {
         seqNum = it->second.first.GetStartingSequence();
     }
